<!-- -------------------- ./mgmt/contacts_page.html -------------------- -->


<?php include "snippets/header-new.html"; ?>

<main class="os-main-content">
	<div class="fr-grid-row fr-grid-row--gutters">
		<div class="fr-col-12">
			<section class="os-table-wrapper fr-container--fluid">
				<header class="os-main-content__header os-table-wrapper__header">
					<div class="fr-grid-row">
						<div class="fr-col">
							<h2 class="fr-h3">Mes contacts</h2>
						</div>
					</div>
				</header>

				<div class="fr-grid-row fr-grid-row--center fr-py-2w">
					<div class="fr-col-12 fr-col-md-8 fr-col-lg-6">


						<form id="user-contacts" class="form-horizontal" method="post" action="<?php echo $this->URL->GetMgmtMethod('ContactsActions'); ?>">

							<input type="hidden" name="RUSERI" value="<?php echo $this->RUSERI; ?>">
							<input type="hidden" name="RUSERI" value="<?php echo $this->RUSERI; ?>">
							<input type="hidden" name="CONTACTS_ACTION" value="">
							<input type="hidden" name="CONTACTS_DEL_MAIL" value="">

							<div id="contacts-table-toolbar">
								<button type="button" id="addContactLine" class="fr-btn fr-btn--sm fr-btn--icon-left fr-icon-user-add-line">Ajouter un contact</button>
							</div>
							

							<table id="contacts-table" class="fr-mx-0"
								data-locale="fr-FR"
								data-toggle="table"  
								data-search="true"
  								data-pagination="true"
								data-ajax="ajaxLoadUserContacts"
								data-loading-template="loadingTemplate"
								data-toolbar="contacts-table-toolbar"
								data-cookie="true"
                        		data-cookie-id-table="contacts-table"
								>
								<thead>
									<tr>
										<th data-field="cmail" data-width="45" data-width-unit="%" data-sortable="true">Email</th>
										<th data-field="cname" data-width="45" data-width-unit="%" data-sortable="true">Nom</th>
										<th data-field="action" data-formatter="filterActionFormatter" data-events="window.operateEvents" class="os-actions" data-width="10" data-width-unit="%">Actions</th>
									</tr>
								</thead>
								<tbody>
									<?php /* if(!empty($this->UCONTACTS)): ?>
									<?php foreach($this->UCONTACTS as $cmail => $cname): ?>
									<tr data-contact-mail="<?php echo $cmail ?>" data-contact-name="<?php echo $cname ?>">
										<td data-contact-form data-contact-mail="<?php echo $cmail ?>">
											<?php echo $cmail ?>
										</td>
										<td data-contact-form data-contact-name="<?php echo $cname ?>">
											<?php echo $cname ?>
										</td>
										<td class="os-actions">
											<div>
												<!-- <button type="button" class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-icon-edit-line edit-contact-line" title="Modifier">
													Modifier
												</button> -->
												
												<button type="button" class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-fi-delete-line delete-contact-line" title="Supprimer le contact">
													Supprimer
												</button>
											</div>
										</td>
									</tr>
									<?php endforeach; ?>
									<?php else: ?>
									<tr id="noContactLine">
										<td colspan="3">Vous n'avez aucun contact enregistré.</td>
									</tr>
									<?php endif; */ ?>
								</tbody>
							</table>
							
							<template id="contact-line-template">
								<div class="bootstrap-table bootstrap-table">
									<table class="fr-mx-0  fr-col-12 table table-bordered">
										<tr>
											<td data-contact-form data-contact-mail="<?php echo @$cmail; ?>" width="40%">
												<input class="fr-input" type="email" name="CONTACTS_ADD_MAIL" placeholder="Email" required />
											</td>
											<td data-contact-form data-contact-name="<?php echo @$cname; ?>" width="40%">
												<input class="fr-input" type="text" name="CONTACTS_ADD_NAME"  placeholder="Nom" required />
											</td>

											<td class="os-actions" width="10%">
												<div style="display: flex; justify-content: space-around;">
												<button type="button" class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-icon-check-line save-contact-line" title="Enregistrer le contact">
													Enregistrer
												</button>
												<button type="button" class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-fi-close-line cancel-edit" title="Annuler">
													Annuler
												</button>
												</div>
											</td>
										</tr>
									</table>
								</div>
							</template>
						</form>
					</div>
				</div>
			</section>
		</div>
	</div>
</main>

<!-- -------------------------------------------------------------------- -->


<!-- -------------------------------------------------------------------- -->

<!-- Optional JavaScript -->
<script src="/pub/jsext/jquery-3.3.1.min.js"></script>
<script src="/pub/jsext/popper.min.js"></script>
<script src="/pub/jsext/jquery_validate_fr.js"></script>

<!-- <link rel="stylesheet" href="https://unpkg.com/bootstrap-table@1.21.4/dist/bootstrap-table.min.css"> -->
<link rel="stylesheet" href="/pub/bootstrap-table-1.21.4/dist/themes/bootstrap-table/bootstrap-table.min.css">
<link rel="stylesheet" href="/pub/css/bootstrap-table-os.css">


<script src="/pub/bootstrap-table-1.21.4/dist/bootstrap-table.min.js"></script>
<script src="/pub/bootstrap-table-1.21.4/dist/themes/bootstrap-table/bootstrap-table.min.js"></script>
<script src="/pub/bootstrap-table-1.21.4/dist/locale/bootstrap-table-fr-FR.min.js"></script>
<script src="/pub/bootstrap-table-1.21.4/dist/extensions/cookie/bootstrap-table-cookie.min.js"></script>



<script>
	(function customizeBootstrapTableDefaults() {
		if (typeof $.fn?.bootstrapTable?.defaults === 'undefined') {
			//if bootstraptable not loaded, get out
			return;
		}

		$.extend($.fn.bootstrapTable.defaults, {
			buttonsPrefix: 'fr-btn', // for DSFR , .fr-btn replaces bootstrap .btn
			classes: 'os-table table table-sm table-bordered table-hover table-striped',
			iconSize: 'sm',
			locale: 'fr-FR',
			pagination: true,
			showExtendedPagination: true,
			pageSize: 10,
			pageList: [10, 25, 50, 100, 'all'],
			search: true,
			height: 'auto',
			paginationVAlign: 'both'
		});

		// unfortunately, small button in DSFR are set with a .fr-btn--sm and not .fr-btn-sm
		// so replace it after bootstrap-table is rendered.
		const osTables = document.querySelectorAll('table');
		osTables.forEach(gnTable => {
			$(gnTable).on('post-body.bs.table', (e, name, args) => {
				const smBtn = gnTable.closest('.bootstrap-table').querySelectorAll('.fr-btn-sm');
				smBtn.forEach(elem => { elem.classList.replace('fr-btn-sm', 'fr-btn--sm') });
			})


			// when setting height: 'auto', the pagination is quite too low, we fix it
			$(gnTable).on('post-header.bs.table', (e, name, args) => {
				const tableContainer = gnTable.closest('.fixed-table-container');
				tableContainer.style.paddingBottom = '1em';
				tableContainer.style.borderBottom = 'none';
			})
		})
	})();

	function ajaxLoadUserContacts(params) {
		$.ajax({
			url: '/mgt/ajaxContactsList',
			method: 'GET',
			success: function (data) {
				params.success({
					'rows': data,
					'total': data.total
				})
			},
			error: function (er) { params.error(er); }
		});		 
	}

	function filterActionFormatter(value, row, index) {
		return ['<div style="display:flex; justify-content: space-around;">',
				/*	'<button type="button" ',
					'class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-fi-edit-line edit-contact-line" ',
					'title="Modifier le contact">Modifier</button >',
				*/
					'<button type="button" ',
					'class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-fi-delete-line delete-contact-line" ',
					'title="Supprimer le contact">Supprimer</button >',
				'</div>'	
		].join('');
	}

	function loadingTemplate(message) {
			return '<div style="display:flex; gap: 1rem;"><span>Chargement en cours...&nbsp;</span><span class="os-spinner" role="status"></span></div>'
		}

	document.addEventListener("DOMContentLoaded", function () {
		const contactsForm = document.querySelector('#user-contacts');
		const contactsTable = contactsForm.querySelector('table#contacts-table');
		const addContactLineButton = contactsForm.querySelector('#addContactLine');

		window.operateEvents = {
			'click .delete-contact-line': function (e, value, row, index) {
				if (confirm("Voulez-vous supprimer le contact " + row.cname + ' (' + row.cmail + ')' + " ?")) {
					contactsForm.querySelector('input[name=CONTACTS_ACTION]').value = 'DEL';
					contactsForm.querySelector('input[name=CONTACTS_DEL_MAIL]').value = row.cmail;
					contactsForm.requestSubmit();
				} else {
					// no delete
				}				
			}
			/*,
			'click .edit-contact-line': function (e, value, row, index) {
				console.log(e);
			}*/
		};

		addContactLineButton.addEventListener('click', function () {
			this.setAttribute('disabled', true);
			const tbody = contactsTable.querySelector("tbody");
			const container = document.querySelector('#contacts-table-toolbar');
			container.addEventListener('click', function (e) {
				let targetLine = null;

				if (e.target.classList.contains('save-contact-line')) {
					e.preventDefault();
					e.stopPropagation();
					targetLine = e.target.closest('tr');
					contactsForm.querySelector('input[name=CONTACTS_ACTION]').value = 'ADD';
					contactsForm.requestSubmit();
				}

				if (e.target.classList.contains('cancel-edit')) {
					e.preventDefault();
					e.stopPropagation();
					targetLine = e.target.closest('tr');
					targetLine.remove();
					addContactLineButton.removeAttribute('disabled');
				}
			});


			const template = document.querySelector('#contact-line-template');
			// Clone the new row and insert it into the table
			const clone = template.content.cloneNode(true);
			tbody.querySelector('#noContactLine')?.setAttribute('hidden', true);
			container.appendChild(clone);
			//tbody.insertBefore(clone, tbody.querySelector(':first-child'));
			const emailField = container.querySelector('input[type=email]');
			//emailField.scrollIntoView();
			emailField.focus();			
		})

		

	});



</script>

<!--  -->
<script>

</script>

</body>

</html>
